#ifndef _TEXT_HPP_
#define _TEXT_HPP_


#include"util.hpp"


namespace text{


struct
Element
{
  uint32_t      pos;
  uint32_t  unicode;

};


void  get_element(Element&  elm);

size_t  get_length();

size_t  reset_pos(int  new_pos);
size_t   seek_pos(int  amount);

void  fill_unicodes();

void  load(const char*  path);

void  reset(const char*      txt);
void  reset(const char16_t*  txt);


const std::vector<char16_t>&  get_char_list();

uint32_t  get_char_count(char16_t  c);

void  print(char16_t  c);


}


#endif




