#ifndef UTIL_HPP
#define UTIL_HPP


#include<cstdint>
#include<cstring>
#include<cstdio>
#include<cstdlib>
#include<cstdarg>
#include<ctime>
#include<string>
#include<vector>
#include<algorithm>
#include<initializer_list>
#include<SDL.h>


#define report  printf("[%8ld] %s %4d %s\n",time(nullptr),__FILE__,__LINE__,__func__)
#define  printd(d)  printf("[printd] %s %8d\n",#d,(d))

#define  rep(v,n)  for(int  v =     0;  v <  (n);  ++v)
#define rrep(v,n)  for(int  v = (n)-1;  v >=  0 ;  --v)


size_t  get_utf8_bytes(unsigned char  c);

int  fget_utf8(FILE*  f);
int  sget_utf8(const char*&  s);

void  print_unicode(char16_t  c);




#endif




